/************************************************************************
 *									*
 *		hr`lCu					*
 *									*
 *				: f[^x[X			*
 *		t@C	: db.c					*
 *		쐬		: s.aizawa				*
 *									*
 ************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "isam.h"

/*	[J֐`	*/
static	void	skip_deleted(DB *, int);
static	void	skip(DB *, long);
static	void	check_bof(DB *, long);
static	void	check_eof(DB *, long);

static	DB	*_db_top_ptr = 0;	/* f[^x[X擪|C^ */

/*=======================================================================
 |
 |		f[^x[XI[v
 |
 |	DB	*db_open(file_name)
 |
 |		char	*file_name;	f[^t@C
 |
 |		Ԓl			ca|C^
 |
 =======================================================================*/
DB	*db_open(char *file_name)
{
	DB	*dbp;

	/* f[^x[XǗGAm */
	if ((dbp = malloc(sizeof(DB))) == NULL) {
		db_err(IE_MEMORY);
		return(NULL);
	}
	memset(dbp, 0, sizeof(DB));

	/* f[^t@CicaejI[v */
	if ((dbp->dp = dbf_open(file_name)) == NULL) {
		db_close(dbp);
		return(NULL);
	}

	check_bof(dbp, 1L);	/* ane`FbN*/

	/* `FC */
	dbp->chain = _db_top_ptr;
	_db_top_ptr = dbp;

	return(dbp);
}

/*=======================================================================
 |
 |		f[^x[X쐬
 |
 |	DB	*db_create(dbf_file_name, dip, n_field)
 |
 |		char	*dbf_file_name;	f[^t@C
 |		DBF_I	*dip;		f[^t@C
 |		int	n_field;	tB[h
 |
 |		Ԓl			ca|C^
 |
 =======================================================================*/
DB	*db_create(char *dbf_file_name, DBF_I *dip, int n_field)
{
	DBF	*dp;

	/* f[^t@C쐬 */
	if ((dp = dbf_create(dbf_file_name, dip, n_field)) == NULL)
		return(NULL);

	dbf_close(dp);	/* f[^t@CN[Y */

	return(db_open(dbf_file_name));
}

/*=======================================================================
 |
 |		\t@Cf[^x[X쐬
 |
 |	DB	*db_create_from(dbf_file_name, str_file_name)
 |
 |		char	*dbf_file_name;	f[^t@C
 |		char	*str_file_name;	\t@C
 |
 |		Ԓl			ca|C^
 |
 =======================================================================*/
DB	*db_create_from(char *dbf_file_name, char *str_file_name)
{
	DBF	*dp;
	FIELD	*flp_name, *flp_type, *flp_len, *flp_dec;
	DBF_I	*dip;
	register int	i, j;
	int	n_field;

	/* \t@CI[v */
	if ((dp = dbf_open(str_file_name)) == NULL) {
		return(NULL);
	}

	/* "FIELD_NAME" tB[ho */
	if ((flp_name = get_field(dp, "FIELD_NAME")) == 0) {
		db_err(IE_STRFILE);
		dbf_close(dp);
		return(NULL);
	}

	/* "FIELD_TYPE" tB[ho */
	if ((flp_type = get_field(dp, "FIELD_TYPE")) == 0) {
		db_err(IE_STRFILE);
		dbf_close(dp);
		return(NULL);
	}

	/* "FIELD_LEN" tB[ho */
	if ((flp_len = get_field(dp, "FIELD_LEN")) == 0) {
		db_err(IE_STRFILE);
		dbf_close(dp);
		return(NULL);
	}

	/* "FIELD_DEC" tB[ho */
	if ((flp_dec = get_field(dp, "FIELD_DEC")) == 0) {
		db_err(IE_STRFILE);
		dbf_close(dp);
		return(NULL);
	}

	/* tB[hGAm */
	n_field = (int)dp->dhp->n_rec;
	if ((dip = calloc(n_field, sizeof(DBF_I))) == NULL) {
		db_err(IE_MEMORY);
		dbf_close(dp);
		return(NULL);
	}

	/* tB[hZbg */
	for (i = 0; i < n_field; i++) {
		dbf_read(dp, (long)(i + 1));
		for (j = 0; j < 10 && flp_name->fad[j] != ' '; j++)
			dip[i].name[j] = flp_name->fad[j];
		dip[i].name[j] = '\0';
		dip[i].type = flp_type->fad[0];
		dip[i].l_field = natoi(flp_len->fad, flp_len->l_field);
		dip[i].l_dec = natoi(flp_dec->fad, flp_dec->l_dec);
	}

	dbf_close(dp);	/* \t@CN[Y */

	/* f[^t@C쐬 */
	dp = dbf_create(dbf_file_name, dip, n_field);

	free(dip);	/* tB[hGA */

	if (dp == NULL)
		return(NULL);

	dbf_close(dp);	/* f[^t@CN[Y */

	return(db_open(dbf_file_name));
}

/*=======================================================================
 |
 |		f[^x[XN[Y
 |
 |	void	db_close(dbp)
 |
 |		DB	*dbp;		ca|C^
 |
 =======================================================================*/
void	db_close(DB *dbp)
{
	DB	**dbpp;
	register int	i;

	/* f[^t@CN[Y */
	if (dbp->dp != NULL)
		dbf_close(dbp->dp);

	/* CfbNXt@CN[Y */
	for (i = 1; i <= dbp->n_idx; i++) {
		if (dbp->ip[i] != NULL)
			idx_close(dbp->ip[i]);
	}

	/* `FC؂藣 */
	for (dbpp = &_db_top_ptr; *dbpp != 0; dbpp = &(*dbpp)->chain) {
		if ((*dbpp) == dbp) {
			*dbpp = (*dbpp)->chain;
			break;
		}
	}

	free(dbp);	/* ǗGA */
}

/*=======================================================================
 |
 |		Sf[^x[XN[Y
 |
 |	void	db_close_all()
 |
 =======================================================================*/
void	db_close_all(void)
{
	while (_db_top_ptr != NULL)
		db_close(_db_top_ptr);
}

/*=======================================================================
 |
 |		t@C|o
 |
 |	void	db_flush(dbp)
 |
 |		DB	*dbp;		ca|C^
 |
 =======================================================================*/
void	db_flush(DB *dbp)
{
	register int	i;

	dbf_flush(dbp->dp);	/* f[^t@CtbV */

	/* CfbNXt@CtbV */
	for (i = 1; i <= dbp->n_idx; i++) {
		if (dbp->ip[i] != NULL)
			idx_flush(dbp->ip[i]);
	}
}

/*=======================================================================
 |
 |		St@C|o
 |
 |	void	db_flush_all()
 |
 =======================================================================*/
void	db_flush_all(void)
{
	DB	*dbp;

	for (dbp = _db_top_ptr; dbp != NULL; dbp = dbp->chain)
		db_flush(dbp);
}

/*=======================================================================
 |
 |		CfbNXt@CI[v
 |
 |	int	db_index(dbp, file_name)
 |
 |		DB	*dbp;		ca|C^
 |		char	*file_name;	CfbNXt@C
 |
 |		Ԓl			CfbNXt@Cԍ
 |
 =======================================================================*/
int	db_index(DB *dbp, char *file_name)
{
	/* CfbNXt@CI[v`FbN */
	if (dbp->n_idx >= MAX_IDX) {
		db_err(IE_IDXOVER);
		return(0);
	}

	/* CfbNXt@CI[v */
	if ((dbp->ip[dbp->n_idx+1] = idx_open(file_name)) == NULL)
		return(0);


	dbp->n_idx++;		/* CfbNXt@CXV */

	/* }X^[CfbNXt@CԍZbg */
	if (dbp->master == 0) {
		dbp->master = dbp->n_idx;
		db_top(dbp);
	}

	return(dbp->n_idx);
}

/*=======================================================================
 |
 |		CfbNXt@C쐬
 |
 |	int	db_idx_create(dbp, file_name, key, uniq)
 |
 |		DB	*dbp;		ca|C^
 |		char	*file_name;	CfbNXt@C
 |		char	*key;		L[
 |		int	uniq;		OFL[̏d@PFȂ
 |
 |		Ԓl			CfbNXt@Cԍ
 |
 =======================================================================*/
int	db_idx_create(DB *dbp, char *file_name, char *key, int uniq)
{
	DBF	*dp;
	IDX	*ip;

	dp = dbp->dp;

	/* CfbNXt@CI[v`FbN */
	if (dbp->n_idx >= MAX_IDX) {
		db_err(IE_IDXOVER);
		return(0);
	}

	/* CfbNXt@C쐬 */
	if ((ip = idx_create(file_name, key, uniq)) == NULL)
		return(0);

	idx_make(dp, ip);	/* CfbNX\z */

	dbp->ip[dbp->n_idx+1] = ip;	/* CfbNX|C^Z[u */

	dbp->n_idx++;		/* CfbNXt@CXV */

	/* }X^[CfbNXt@CԍZbg */
	if (dbp->master == 0) {
		dbp->master = dbp->n_idx;
		db_top(dbp);
	}

	return(dbp->n_idx);
}

/*=======================================================================
 |
 |		}X^[CfbNX؂ւ
 |
 |	void	db_chgidx(dbp, n)
 |
 |		DB	*dbp;		ca|C^
 |		int	n;		CfbNXt@Cԍ
 |
 =======================================================================*/
void	db_chgidx(DB *dbp, int n)
{
	dbp->master = n;	/* }X^[CfbNXԍZbg */
	db_top(dbp);		/* 擪R[h */
}

/*=======================================================================
 |
 |		CfbNXt@Cɂ錟
 |
 |	void	db_search(dbp, key, len)
 |
 |		DB	*dbp;		ca|C^
 |		char	*key;		镶
 |		int	len;		镶̒
 |
 =======================================================================*/
void	db_search(DB *dbp, char *key, int len)
{
	DBF	*dp;
	IDX	*ip;
	double	a;
	long	rno;

	/* |C^Zbg */
	dp = dbp->dp;
	ip = dbp->ip[dbp->master];

	/* CfbNXt@CȂΉȂ */
	if (ip == NULL)
		return;

	if (ip->ihp->type != 0) {
		/* 𐔒lɕϊ */
		a = natof(key, len);
		key = (char *)&a;
		len = 8;
	}

	rno = idx_search(ip, key, len);		/*  */

	if (_db_set_deleted && rno != 0L) {
		/* 폜R[hXLbv */
		while (dbf_check_deleted(dp, rno)) {
			if ((rno = idx_next(ip)) == 0)
				break;
			if (idx_compare(ip, key, len) != 0) {
				rno = 0;
				break;
			}
		}
	}

	check_eof(dbp, rno);	/* dne`FbN */
}

/*=======================================================================
 |
 |		L[Ɉv郌R[h߂
 |
 |	long	db_count(dbp, key, len)
 |
 |		DB	*dbp;		ca|C^
 |		char	*key;		镶
 |		int	len;		镶̒
 |
 |		Ԓl			L[ɈvR[h
 |
 =======================================================================*/
long	db_count(DB *dbp, char *key, int len)
{
	DBF	*dp;
	IDX	*ip;
	double	a;
	long	count, rno;

	/* |C^Zbg */
	dp = dbp->dp;
	ip = dbp->ip[dbp->master];

	/* CfbNXt@CȂΉȂ */
	if (ip == NULL)
		return(0L);

	if (ip->ihp->type != 0) {
		/* 𐔒lɕϊ */
		a = natof(key, len);
		key = (char *)&a;
		len = 8;
	}

	count = 0;
	if ((rno = idx_search(ip, key, len)) != 0) {	/*  */
		for (;;) {
			if (_db_set_deleted == 0
					|| dbf_check_deleted(dp, rno) == 0)
				count++;
			if ((rno = idx_next(ip)) == 0)
				break;
			if (idx_compare(ip, key, len) != 0)
				break;
		}
	}

	check_eof(dbp, rno);	/* dne`FbN */

	return(count);
}

/*=======================================================================
 |
 |		R[hǉ
 |
 |	void	db_store(dbp, rec)
 |
 |		DB	*dbp;		ca|C^
 |		char	*rec;		ǉ郌R[hf[^ւ̃|C^
 |
 =======================================================================*/
void	db_store(DB *dbp, char *rec)
{
	DBF	*dp;
	IDX	*ip;
	register int	i;
	DBF_H	*dhp;
	IDX_H	*ihp;
	char	kbuf[100];

	/* |C^Zbg */
	dp = dbp->dp;
	dhp = dp->dhp;

	dp->rbp[0] = ' ';	/* 폜R[htONA */
	memcpy(dp->rbp+1, rec, dhp->l_rec-1);	/* f[^Rs[ */

	/* f[^t@Cɒǉ */
	dbp->rno = ++dhp->n_rec;
	dbf_write(dp, dbp->rno);
	dp->w_flag = 1;

	/* CfbNXt@CXV */
	for (i = 1; i <= dbp->n_idx; i++) {
		ip = dbp->ip[i];
		ihp = ip->ihp;

		if (get_key(dp, ihp, kbuf) != 0)
			idx_store(ip, kbuf, dhp->n_rec);
	}

	/* CfbNXt@C̃|C^Zbg */
	db_set(dbp, dbp->rno);
}

/*=======================================================================
 |
 |		R[hXV
 |
 |	void	db_update(dbp, rec)
 |
 |		DB	*dbp;		ca|C^
 |		char	*rec;		XV郌R[hf[^ւ̃|C^
 |
 =======================================================================*/
void	db_update(DB *dbp, char *rec)
{
	DBF	*dp;
	IDX	*ip;
	register int	i;
	DBF_H	*dhp;
	IDX_H	*ihp;
	long	rno;
	char	kbuf1[100], kbuf2[100];

	/* ane܂͂dneȂG[ */
	if (dbp->bof || dbp->eof) {
		db_err(IE_EOF);
		return;
	}

	/* |C^Zbg */
	dp = dbp->dp;
	dhp = dp->dhp;

	dbf_read(dp, dbp->rno);		/* R[hǂݍ */

	/* CfbNXt@CXV */
	for (i = 1; i <= dbp->n_idx; i++) {
		ip = dbp->ip[i];
		ihp = ip->ihp;

		if (get_key(dp, ihp, kbuf1) != 0) {
			rno = idx_search(ip, kbuf1, ihp->l_key);
			while (rno != dbp->rno && rno != 0)
				rno = idx_next(ip);
			if (rno != 0) {
				memcpy(dp->rbp+1, rec, dhp->l_rec-1);
				get_key(dp, ihp, kbuf2);
				if (memcmp(kbuf1, kbuf2, ihp->l_key) != 0) {
					idx_delete(ip);
					idx_store(ip, kbuf2, rno);
				}
				dp->rno = 0;
				dbf_read(dp, dbp->rno);	/* R[hǂݍ */
			}
		}
	}

	/* f[^t@CXV */
	memcpy(dp->rbp+1, rec, dhp->l_rec-1);
	dbf_write(dp, dbp->rno);

	/* CfbNXt@C̃|C^Zbg */
	db_set(dbp, dbp->rno);
}

/*=======================================================================
 |
 |		R[h폜
 |
 |	void	db_delete(dbp)
 |
 |		DB	*dbp;		ca|C^
 |
 =======================================================================*/
void	db_delete(DB *dbp)
{
	/* ane܂͂dneȂG[ */
	if (dbp->bof || dbp->eof) {
		db_err(IE_EOF);
		return;
	}

	dbf_delete(dbp->dp, dbp->rno);	/* 폜}[NZbg */

	skip_deleted(dbp, 1);		/* 폜R[hXLbv */
}

/*=======================================================================
 |
 |		R[h
 |
 |	void	db_recall(dbp)
 |
 |		DB	*dbp;		ca|C^
 |
 =======================================================================*/
void	db_recall(DB *dbp)
{
	/* ane܂͂dneȂG[ */
	if (dbp->bof || dbp->eof) {
		db_err(IE_EOF);
		return;
	}

	dbf_recall(dbp->dp, dbp->rno);	/* 폜}[N */
}

/*=======================================================================
 |
 |		R[h̕I폜
 |
 |	void	db_delete2(dbp)
 |
 |		DB	*dbp;		ca|C^
 |
 =======================================================================*/
void	db_delete2(DB *dbp)
{
	DBF	*dp;
	DBF_H	*dhp;
	IDX	*ip;
	int	i;
	char	*rbufp;
	long	rno;
	char	kbuf[100];

	/* ane܂͂dneȂG[ */
	if (dbp->bof || dbp->eof) {
		db_err(IE_EOF);
		return;
	}

	dp = dbp->dp;
	dhp = dp->dhp;

	/* R[hۑGAm */
	if ((rbufp = malloc(dp->dhp->l_rec - 1)) == 0) {
		db_err(IE_MEMORY);
		return;
	}

	dbf_read(dp, dhp->n_rec);	/* ŏIR[hǂݍ */

	/* IŏIR[hCfbNXt@C폜 */
	for (i = 1; i <= dbp->n_idx; i++) {
		ip = dbp->ip[i];

		if (get_key(dp, ip->ihp, kbuf) != 0) {
			rno = idx_search(ip, kbuf, ip->ihp->l_key);
			while (rno != dhp->n_rec && rno != 0)
				rno = idx_next(ip);
			if (rno != 0)
				idx_delete(ip);		/* L[̍폜 */
		}
	}

	/* ŏIR[hȊȌꍇA폜郌R[hɍŏIR[h㏑ */
	if (dbp->rno != dhp->n_rec) {
		memcpy(rbufp, dp->rbp + 1, dhp->l_rec - 1);
		db_update(dbp, rbufp);
	}

	free(rbufp);

	dhp->n_rec--;	/* R[h|P */
	dp->update = 1;		/* t@CXVtOZbg */

	if (dhp->n_rec == 0)	/* OɂȂꍇ͂aneAdneZbg */
		dbp->eof = dbp->bof = 1;

	/* t@CTCY𒲐 */
	chsize(dp->fh, dhp->l_header + dhp->l_rec * dhp->n_rec);
}

/*=======================================================================
 |
 |		R[h|C^擪R[hɃZbg
 |
 |	void	db_top(dbp)
 |
 |		DB	*dbp;		ca|C^
 |
 =======================================================================*/
void	db_top(DB *dbp)
{
	IDX	*ip;

	ip = dbp->ip[dbp->master];

	check_bof(dbp, (ip == NULL) ? 1L : idx_top(ip));

	skip_deleted(dbp, 1);	/* 폜R[hXLbv */
}

/*=======================================================================
 |
 |		R[h|C^ŏIR[hɃZbg
 |
 |	void	db_bottom(dbp)
 |
 |		DB	*dbp;		ca|C^
 |
 =======================================================================*/
void	db_bottom(DB *dbp)
{
	IDX	*ip;

	ip = dbp->ip[dbp->master];

	check_eof(dbp, (ip == NULL) ? dbp->dp->dhp->n_rec : idx_bottom(ip));

	skip_deleted(dbp, -1);	/* 폜R[hXLbv */
}

/*=======================================================================
 |
 |		R[h|C^w肳ꂽR[hɃZbg
 |
 |	void	db_set(dbp, recno)
 |
 |		DB	*dbp;		ca|C^
 |		long	recno;		R[hԍ
 |
 =======================================================================*/
void	db_set(DB *dbp, long recno)
{
	DBF	*dp;
	IDX	*ip;
	long	rno;
	char	kbuf[100];
	
	/* |C^Zbg */
	dp = dbp->dp;
	ip = dbp->ip[dbp->master];

	if (ip != NULL) {
		/* CfbNXt@Cꍇ */
		dbf_read(dp, recno);	/* R[hǂݍ */

		/* CfbNXt@C̎w肳ꂽR[hԍT */
		if (get_key(dp, ip->ihp, kbuf) != 0) {
			rno = idx_search(ip, kbuf, ip->ihp->l_key);
			while (rno != recno && rno != 0)
				rno = idx_next(ip);
		}
	}

	check_eof(dbp, recno);	/* dne`FbN */
}

/*=======================================================================
 |
 |		R[h|C^̑Oړ
 |
 |	void	db_skip(dbp, n)
 |
 |		DB	*dbp;		ca|C^
 |		long	n;		ړR[h
 |
 =======================================================================*/
void	db_skip(DB *dbp, long n)
{
	if (_db_set_deleted == 0)
		skip(dbp, n);	/* R[h|C^ړ */
	else {
		if (n < 0) {
			while (n++) {
				skip(dbp, -1L);
				skip_deleted(dbp, -1);/* 폜R[hXLbv*/
			}
		} else if (n > 0) {
			while (n--) {
				skip(dbp, 1L);
				skip_deleted(dbp, 1);/* 폜R[hXLbv */
			}
		}
	}
}

/*=======================================================================
 |
 |		CfbNXt@Cč\z
 |
 |	void	db_reindex(dbp)
 |
 |		DB	*dbp;		ca|C^
 |
 =======================================================================*/
void	db_reindex(DB *dbp)
{
	DBF	*dp;
	register int	i;

	dp = dbp->dp;

	for (i = 1; i <= dbp->n_idx; i++) {
		idx_make(dp, dbp->ip[i]);	/* CfbNX\z */
	}

	db_top(dbp);
}

/*=======================================================================
 |
 |		폜R[ht@Cォ폜
 |
 |	void	db_pack(dbp)
 |
 |		DB	*dbp;		ca|C^
 |
 =======================================================================*/
void	db_pack(DB *dbp)
{
	dbf_pack(dbp->dp);	/* 폜R[h̍폜 */
	db_reindex(dbp);	/* CfbNXt@Cč\z */
}

/*=======================================================================
 |
 |		JgR[hǂݍ
 |
 |	void	db_read(dbp, p)
 |
 |		DB	*dbp;		ca|C^
 |		char	*p;		R[hǂݍ݃obt@|C^
 |
 =======================================================================*/
void	db_read(DB *dbp, char *p)
{
	DBF	*dp;

	/* ane܂͂dneȂG[ */
	if (dbp->bof || dbp->eof) {
		db_err(IE_EOF);
		return;
	}

	dp = dbp->dp;
	dbf_read(dp, dbp->rno);		/* ǂݍ */
	memcpy(p, dp->rbp + 1, dp->dhp->l_rec - 1);	/* obt@ɃRs[ */
}

/*=======================================================================
 |
 |		f[^t@CRs[
 |
 |	void	db_copy(dbp1, dbp2)
 |
 |		DB	*dbp1;		Rs[ca|C^
 |		DB	*dbp2;		Rs[ca|C^
 |
 =======================================================================*/
void	db_copy(DB *dbp1, DB *dbp2)
{
	dbf_copy(dbp1->dp, dbp2->dp);	/* f[^t@CRs[ */
	db_reindex(dbp2);		/* CfbNXt@Cč\z */
}

/*=======================================================================
 |
 |		폜R[h`FbN
 |
 |	int	db_check_deleted(dbp)
 |
 |		DB	*dbp;		ca|C^
 |
 |		Ԓl			OFʏ탌R[h@PF폜R[h
 |					-1FG[
 |
 =======================================================================*/
int	db_check_deleted(DB *dbp)
{
	/* ane܂͂dneȂG[ */
	if (dbp->bof || dbp->eof) {
		db_err(IE_EOF);
		return(-1);
	}

	return(dbf_check_deleted(dbp->dp, dbp->rno));
}

/*=======================================================================
 |
 |		폜R[h̃XLbv
 |
 |	void	skip_deleted(dbp, n)
 |
 |		DB	*dbp;		ca|C^
 |		int	n;		PFփXLbv@|PFOփXLbv
 |
 =======================================================================*/
static	void	skip_deleted(DB *dbp, int n)
{
	DBF	*dp;

	if (_db_set_deleted != 0 && n != 0) {
		dp = dbp->dp;
		while (!(dbp->bof || dbp->eof) && dbf_check_deleted(dp, dbp->rno)) {
			skip(dbp, (long)n);
		}
	}
}

/*=======================================================================
 |
 |		R[h̑Oړ
 |
 |	void	skip(dbp, n)
 |
 |		DB	*dbp;		ca|C^
 |		long	n;		ړR[h
 |
 =======================================================================*/
static	void	skip(DB *dbp, long n)
{
	DBF	*dp;
	IDX	*ip;
	long	rno;

	dp = dbp->dp;
	ip = dbp->ip[dbp->master];

	if (ip == NULL) {
		/* CfbNXt@CȂꍇ */
		rno = dbp->rno + n;
		if (rno <= 0)
			check_bof(dbp, 0L);
		else if (rno > dp->dhp->n_rec)
			check_eof(dbp, 0L);
		else
			check_eof(dbp, rno);
	} else {
		/* CfbNXt@Cꍇ */
		if (n > 0) {
			if (dbp->bof) {
				rno = idx_top(ip);
				n--;
			}
			while (n-- != 0) {
				rno = idx_next(ip);
				if (rno == 0)
					break;
			}
			check_eof(dbp, rno);
		} else if (n < 0) {
			if (dbp->eof) {
				rno = idx_bottom(ip);
				n++;
			}
			while (n++ != 0) {
				rno = idx_back(ip);
				if (rno == 0)
					break;
			}
			check_bof(dbp, rno);
		}
	}
}

/*=======================================================================
 |
 |		ane`FbN
 |
 |	void	check_bof(dbp, rno)
 |
 |		DB	*dbp;		ca|C^
 |		long	rno;		R[hԍ
 |
 =======================================================================*/
static	void	check_bof(DB *dbp, long rno)
{
	if (dbp->dp->dhp->n_rec == 0) {
		/* R[hPȂꍇ */
		dbp->rno = 1;
		dbp->bof = 1;
		dbp->eof = 1;
	} else {
		if (rno == 0) {
			dbp->rno = 1;
			dbp->bof = 1;
			dbp->eof = 0;
		} else {
			dbp->rno = rno;
			dbp->bof = 0;
			dbp->eof = 0;
		}
	}
}

/*=======================================================================
 |
 |		dne`FbN
 |
 |	void	check_eof(dbp, rno)
 |
 |		DB	*dbp;		ca|C^
 |		long	rno;		R[hԍ
 |
 =======================================================================*/
static	void	check_eof(DB *dbp, long rno)
{
	if (dbp->dp->dhp->n_rec == 0) {
		/* R[hPȂꍇ */
		dbp->rno = 1;
		dbp->bof = 1;
		dbp->eof = 1;
	} else {
		if (rno == 0) {
			dbp->rno = dbp->dp->dhp->n_rec + 1;
			dbp->bof = 0;
			dbp->eof = 1;
		} else {
			dbp->rno = rno;
			dbp->bof = 0;
			dbp->eof = 0;
		}
	}
}
